/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  map.c -- display sector map of current planet
 */

#define DISP_DATA 1

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include <curses.h>
extern float compatibility();
char desshow();

int map_racedata;

map(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
register int i;
int map_pdata,inv,flag;
planettype *p;
placetype where;

   where = Getplace(Playernum, args[1],0);

   if (where.err) return;

   if (where.level==LEVEL_PLAN) {
  
  	openpdata(&map_pdata);
  	getplanet(map_pdata,&p,Stars[where.snum]->planetpos[where.pnum]);
  	close_file(map_pdata);
 
  	show_map(Playernum, where.snum, where.pnum, p, DISP_DATA, 0);	
					/* 0 is begin iq*/

  	free(p);

	if (Stars[where.snum]->stability > 50)
		notify(Playernum, "WARNING! This planet's primary is unstable.\n");

   } else {
	orbit(Playernum, APcount, argn,args);	/* make orbit map instead */
   }

}



show_map(Playernum, snum, pnum, p, show,iq)
int Playernum;
int snum, pnum;
planettype *p;
int show;
int iq;
{
reg int x,y,i,f,address,owned1;
boolean cap_inv;
int sh,map_sectdata,map_shdata;
shiptype *s;
char shiplocs[MAX_X][MAX_Y];
shiptype **ships;
hugestr output;
char temp[1024], buf[1024];

  bzero((char *)shiplocs, sizeof(shiplocs));

  opensectdata(&map_sectdata);
  getsmap(map_sectdata, Smap, p);
  close_file(map_sectdata);
   /* traverse ship list on planet; find out if we can look at 
       ships here. */
	iq |= p->info[Playernum-1].numsectsowned;
	sh = p->ships;
	
  openshdata(&map_shdata);
 ships = (shiptype **)malloc((Numships(map_shdata)+1) * sizeof(shiptype *) );
		while (sh) {

		(void)getship(map_shdata,&ships[sh], sh);

				/* need crew to sight, except for probes*/
		if(ships[sh]->owner == Playernum && 
			(ships[sh]->popn || (ships[sh]->type==OTYPE_PROBE)
				|| (ships[sh]->type == OTYPE_VN))) 
		  iq = 1;
		sh = ships[sh]->nextship;
	}
close_file(map_shdata);
	if (iq) {
  	  sh = p->ships;
	  while (sh) {
		s = ships[sh]; 
      		if (s->is_alive && s->is_docked && (s->whatdest==LEVEL_PLAN))
			if( (s->xpos < p->Maxx) && (s->xpos >= 0.0) &&
			(s->ypos < p->Maxy) && (s->ypos >= 0.0) )
		  shiplocs[(int)s->xpos][(int)s->ypos] = Shipltrs[s->type];

		sh = s->nextship;
		free(s); 
	  }
	}
   free(ships);

  close_file(map_shdata);

/* report that this is a planet map */
	sprintf(output, "$");

	sprintf(buf, "%s;", Stars[snum]->pnames[pnum]);	
	str_cat(output, buf);

	sprintf(buf, "%d;%d;%d;", p->Maxx, p->Maxy,show);
	str_cat(output, buf);

	free(Race);
	openracedata(&map_racedata);
	getrace(map_racedata, &Race, Playernum);
	close_file(map_racedata);

/* send map data */
 for(y=0; y<p->Maxy; y++)
     for (x=0; x<p->Maxx; x++) {
	owned1 = (Sector(*p,x,y).owner==Playernum);
	if (shiplocs[x][y]) {
		if(owned1 && Race->inverse)
			sprintf(buf,"1%c", shiplocs[x][y]);
		else
			sprintf(buf,"0%c", shiplocs[x][y]);
		} else {
		if(owned1 && Race->inverse)
	    		sprintf(buf,"1%c", desshow(Playernum, p,x,y, Race));
		else
	    		sprintf(buf,"0%c", desshow(Playernum, p,x,y, Race));
		}
	str_cat(output, buf);
     }

notify(Playernum, output);

     if (show){

	sprintf(temp, "    Sects %s: %u", Race->Thing ? "covered" : "owned", 
			p->info[Playernum-1].numsectsowned);
	sprintf(buf, "  Aliens:");
	str_cat(temp, buf);
	  if (p->is_explored || Race->tech >= TECH_EXPLORE) {
		  for (i=1; i<MAXPLAYERS; i++)
			if (p->info[i-1].numsectsowned && i!=Playernum) {
			   f=1;
			   sprintf(buf, "%c%d", isset(Race->atwar,i) ? '*' : ' ', i);
			    str_cat(temp, buf);
			}
		  if (!f) str_cat(temp, "(none)");
	  } else {
		str_cat(temp, "???");
	}
str_cat(temp, "\n");
notify(Playernum, temp);

       sprintf(temp, "      Mobilization : %3d (%3d)     Compatibility: %.2f%%",
		p->info[Playernum-1].comread,
		p->info[Playernum-1].mob_set,
		compatibility(p,Race));
       if(p->conditions[TOXIC]>50) {
	       sprintf(buf,"    (%d%% TOXIC)",p->conditions[TOXIC]);
		str_cat(temp, buf);
		}

str_cat(temp, "\n");
notify(Playernum, temp);

       sprintf(temp, "Resource stockpile : %-9u    Fuel stockpile: %u\n",
		p->info[Playernum-1].resource,
		p->info[Playernum-1].fuel);
notify(Playernum, temp);

       sprintf(temp, "      Destruct cap : %u%26s: %u (%u)\n",p->info[Playernum-1].destruct,
				Race->Thing ? "Tons of biomass" : "Total Population", p->popn, 
		round_rand(.01*(100.-p->conditions[TOXIC])*p->maxpopn) );

notify(Playernum, temp);
 }

}



char desshow(Playernum, p,x,y,r)
int Playernum;
reg planettype *p;
reg int x,y;
racetype *r;
{
reg sectortype *s;

s = &Sector(*p,x,y);

if (s->VN)
	return Shipltrs[OTYPE_VN];

if(s->owner && !r->geography)
	if(!r->inverse || s->owner != Playernum)
		if(!r->double_digits)
			return s->owner %10 + '0'; 
		else {
			if (s->owner < 10 || x % 2)
				return s->owner % 10 + '0';
			else
				return s->owner / 10 + '0';
			}

   if (s->is_wasted) 
	return CHAR_WASTELAND;
   switch (s->des) {
     	case DES_SEA: return CHAR_SEA;
     	case DES_LAND: return CHAR_LAND;
     	case DES_MOUNT: return CHAR_MOUNT;
     	case DES_GAS: return CHAR_GAS;
     	case DES_PLATED: return CHAR_PLATED;
     	case DES_ICE: return CHAR_ICE;
     	default: return('!');
   }


}

