/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  order.c -- give orders to ship
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <curses.h>
#include <ctype.h>
#include <signal.h>
#include <math.h>

char *prin_aimed_at(), *prin_ship_dest();

int order_shdata,order_pdata,order_stardata;
int n_ships;
static boolean first,prerror,was_obj = 0;
boolean Order_types[NUMSTYPES];

order(Playernum, APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int shipno, i;
int order_shdata = NEUTRAL_FD;
int sh, pdata;
planettype *p; 

for (i=0; i<NUMSTYPES; i++) Order_types[i]=0;

if(argn==1) {	/* display all ship orders */
		switch(Dir[Playernum-1].level) {
			case LEVEL_UNIV:
      				sh = Sdata.ships;
					DispOrdersHeader(Playernum);
       					while (sh)
						DispOrders(Playernum, sh, &sh, 0);
				break;
			case LEVEL_STAR:
      				sh = Stars[Dir[Playernum-1].snum]->ships;
					DispOrdersHeader(Playernum);
       					while (sh)
						DispOrders(Playernum, sh, &sh, 0);
				break;
			case LEVEL_PLAN:
 				openpdata(&pdata);
 				getplanet(pdata,&p,
					Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
 				close_file(pdata);
				sh = p->ships;
					DispOrdersHeader(Playernum);
       					while (sh)
						DispOrders(Playernum, sh, &sh, 0);
				free(p);
				break;
			case LEVEL_SHIP:
				sh = Dir[Playernum-1].shipno;
					DispOrdersHeader(Playernum);
					DispOrders(Playernum, sh, &sh, 0);
				break;
			default:
				notify(Playernum, "Bad scope.\n");
				break;
		}
				
} else if (argn>=2) {		/* display one ship's orders (if argn==2), otherwise assigne orders */

	if(*args[1] == '#' || isdigit(*args[1])) {
	sscanf(args[1]+(args[1][0]=='#'),"%d",&shipno);

 openshdata(&order_shdata);
 n_ships = Numships(order_shdata);
close_file(order_shdata);

	if(shipno <=0 || shipno >  n_ships) {
		sprintf(buf, "Illegal ship number %d.\n", shipno);
		notify(Playernum, buf);
		return;		
		}

	if(argn > 2)
		   give_orders(Playernum, APcount, argn, args, shipno, 0);

/* display the orders anyway */
	DispOrdersHeader(Playernum);
	DispOrders(Playernum, shipno, &sh, 0);
	} else {		/* you want to order all types on this level */
		int l;
		l = strlen(args[1]);

		while (l--) {
	   		i = NUMSTYPES;
	   		while (--i && Shipltrs[i]!=args[1][l]);
		   if (Shipltrs[i]!=args[1][l]) {
			sprintf(buf,"'%c' -- no such ship letter\n",args[1][l]);
			notify(Playernum, buf);
		   } else
			Order_types[i] = 1;
	}
		

switch(Dir[Playernum-1].level) { 
  case LEVEL_PLAN:
 	openpdata(&pdata);
 	getplanet(pdata,&p,
	Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
 	close_file(pdata);
      	shipno = p->ships;
	      break; 
   case LEVEL_STAR:
      	shipno = Stars[Dir[Playernum-1].snum]->ships;
	      break; 
   default:
	notify(Playernum, "You can't do multiple orders from this level. Must be planet of star.\n");
		return;		
		}

	DispOrdersHeader(Playernum);
       	while (shipno) {
		if(argn > 2)
		give_orders(Playernum, APcount, argn, args, shipno, 1);
		DispOrders(Playernum, shipno, &shipno, 1);
					}


	   }
	} else
		notify(Playernum, "I don't understand what you mean.\n");
		
}


int give_orders(Playernum, APcount, argn, args, shipno, check)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int shipno;
int check;
{
 boolean Mod=0,q=0,redraw=1;
 placetype where,pl;
 int i = 0, j=0, in_list=0;
 shiptype *ship, *oldship, ship2;
 char c,s[PLACENAMESIZE];
 planettype *planet;

 openshdata(&order_shdata);
 if (!getship(order_shdata,&ship,shipno)) {
	notify(Playernum, "order:error in getship.\n");
	return;
 }
close_file(order_shdata);
if(ship->type == OTYPE_CANIST)
  i=1;

if(check) {
	in_list = 0;
	for(j=0; j<NUMSTYPES; j++) {
		if(Order_types[j] && ship->type==j) in_list = 1;
		}
	if(!in_list) {
			free(ship);
			return;
			}
		}

 if (ship->owner==Playernum) {
 
    if (!ship->is_alive) {
	sprintf(buf, "%s #%d has been destroyed.\n", Shipnames[ship->type], shipno);
	notify(Playernum, buf);
	free(ship);
	return;
    } else {

      if (!ship->active) {
	sprintf(buf, "%s #%d is irradiated (%d); it cannot be give orders.\n", 
			Shipnames[ship->type], shipno,ship->rad);
	notify(Playernum, buf);
	free(ship);
	return;
      }
      if (ship->type != OTYPE_TRANSDEV && !ship->popn && 
	  Max_crew(ship)) {
	sprintf(buf, "%s #%d has no crew and is not a robotic ship.\n",
		Shipnames[ship->type], shipno);
	notify(Playernum, buf);
	free(ship);
	return;
      }

    }

	i=strlen(args[2]);

       if (!strncmp(args[2],"defense",i)) {
		if (can_bombard(ship) || ship->type == OTYPE_GR) {
			if(!strncmp(args[3],"off", strlen(args[3]))) {
				ship->protect.planet = 0;
				notify(Playernum, "Planetary defense canceled.\n");
			} else {
				ship->protect.planet = 1;
				notify(Playernum, "Ship assigned to planetary defense.\n");
			}
		} else {
				notify(Playernum, "That ship cannot be assigned those orders.\n");
				free(ship);
				return;
		}
         } else if (!strncmp(args[2],"jump",i)) {
		if(Shipdata[ship->type][ABIL_JUMP]) {
			if(!strncmp(args[3],"off", strlen(args[3]))) {
				ship->hyper_drive.on = 0;
				notify(Playernum, "Hyper drive turned off.\n");
				} else {
				if(ship->whatdest != LEVEL_STAR) {
				notify(Playernum, "Destination must be star.\n");
				free(ship);
				return;
						}
				ship->hyper_drive.on = 1;
				ship->navigate.on = 0;
				notify(Playernum, "Hyper drive engine's activated.\n");
/* estimate how much fuel it will cost for this ship to get there */
				}
			} else {
		notify(Playernum, "This ship does not have hyper drive capability.\n");
		free(ship);
		return;
			}

         } else if (!strncmp(args[2],"protect",i)) {

	sscanf(args[3]+(args[3][0]=='#'),"%d",&j);

		if(j < 0 || j > n_ships || j==shipno) {
				notify(Playernum, "You can't protect that!\n");
				free(ship);
				return;
			}
		  if (can_bombard(ship) || ship->type==OTYPE_GR) {
				if(!j) {
					ship->protect.on = 0;
					notify(Playernum, "Protection orders halted.\n");
				} else {
					ship->protect.on = 1;
					ship->protect.ship = j;
					sprintf(buf, "Protecting ship #%d.\n", j);
					notify(Playernum, buf);
					}

			} else {
				notify(Playernum, "That ship cannot protect.\n");
				free(ship);
				return;
			}
       } else if (!strncmp(args[2],"navigate",i)) {
		if(argn >= 5) {
			ship->navigate.on = 1;
			ship->navigate.bearing = atoi(args[3]);
			ship->navigate.turns = atoi(args[4]);
			sprintf(buf, "Navigating %d degrees for %d turns.\n",
				ship->navigate.bearing, ship->navigate.turns);
			notify(Playernum, buf);
		} else {
			ship->navigate.on = 0;		
			}
		if(ship->hyper_drive.on) {
			ship->hyper_drive.on = 0;
			notify(Playernum, "Hyper drive turned off.\n");
			}
       } else if (!strncmp(args[2],"switch",i)) {
		if(has_switch(ship)) {
			ship->on = !ship->on;
		} else {
			sprintf(buf, "That ship does not have an on/off setting.\n");
			notify(Playernum, buf);
			free(ship);
			return;
			}
		if(ship->on) {
			notify(Playernum, "Turned on.\n");
			      switch (ship->type) {
				case STYPE_MINE:
					notify(Playernum, "Mine armed and ready.\n");
					break;
				case OTYPE_TRANSDEV:
					notify(Playernum, "Transporter ready to receive.\n");
					break;
				default: break;
			      }
		} else {
			notify(Playernum, "Turned off.\n");
			      switch (ship->type) {
				case STYPE_MINE:
					notify(Playernum, "Mine disarmed.\n");
					break;
				case OTYPE_TRANSDEV:
					notify(Playernum, "No longer receiving.\n");
					break;
				default: break;
			      }
		}
       } else if (!strncmp(args[2],"destination",i)) {
		    if (speed_rating(ship)) {
      			if (ship->is_docked) {
			    notify(Playernum, "That ship is docked; use undock or launch first.\n");
			free(ship);
			return;
      			} 
			where = Getplace(Playernum, args[3], 1);
		      if (!where.err) {
			if (where.level==LEVEL_SHIP) {
			    	ship->destshipno = where.shipno;
				ship->whatdest = LEVEL_SHIP;
			} else {
			    ship->whatdest = where.level;
			    ship->deststar = where.snum;
			    ship->destpnum = where.pnum;
			}
		      } else {
			notify(Playernum, "Illegal destination.\n");
			free(ship);
			return;			
			}

		     sprintf(buf, "Ship's destination set to %*s\n", -PLACENAMESIZE, 
			prin_ship_dest(Playernum, ship) );
			notify(Playernum, buf);			

			} else {
				notify(Playernum, "That ship cannot be launched.\n");
				free(ship);
				return;
			}
       } else if (!strncmp(args[2],"evade",i)) {
		    if (Max_crew(ship) && Max_speed(ship)) {
		if(!strlen(args[3],"on",strlen(args[3]))) {
			ship->protect.evade = 1;
			notify(Playernum, "Ship is undergoing evasive maneuvers.\n");
		} else {
			ship->protect.evade = 0;
			notify(Playernum, "Ship no longer undergoing evasive maneuvers.\n");
		}
		} else {
			notify(Playernum, "You can't make this type of ship do this.\n");
			free(ship);
			return;
			}

       } else if (!strncmp(args[2],"bombard",i)) {
		if (ship->type!=OTYPE_OMCL) {
		    if (can_bombard(ship)) {
			if(!strncmp(args[3],"off",strlen(args[3]))) {
				ship->bombard = 0;
				notify(Playernum, "Bombardment option turned off.\n");				
			} else {
				ship->bombard = 1;
				notify(Playernum, "Ship will bombard upon reaching its destination.\n");
			}

		    } else {
			notify(Playernum, "This type of ship cannot be set to retaliate.\n");
			}
		}
       } else if (!strncmp(args[2],"retaliate",i)) {
		if (ship->type!=OTYPE_OMCL) {
		    if (can_bombard(ship) || ship->type==OTYPE_GR) {
			if(!strncmp(args[3],"off",strlen(args[3]))) {
				ship->protect.self = 0;
				notify(Playernum, "Retaliation option turned off.\n");				
			} else {
				ship->protect.self = 1;
				notify(Playernum, "Ship will retaliate if attacked and damaged.\n");
			}

		    } else {
			notify(Playernum, "This type of ship cannot be set to retaliate.\n");
			}
		}
       } else if (!strncmp(args[2],"speed",i)) {
		if (speed_rating(ship)) {
			j = atoi(args[3]);			
			if(j < 0) {
				notify(Playernum, "Specify a positive speed.\n");
				free(ship);
				return;
			} else {
				if(j > speed_rating(ship)) j = speed_rating(ship);
				ship->speed = j;
				sprintf(buf, "Ship speed set to %d.\n", j);
				notify(Playernum, buf);
			}

		} else {
			notify(Playernum, "This ship does not have a speed rating.\n");
			free(ship);
			return;
		}

      } else if(!strncmp(args[2], "explosive", i)) {
		if(ship->type==STYPE_MINE) {
			ship->mine.mode = 1;
			notify(Playernum, "This mine is set for explosive mode.\n");
		} else {
			notify(Playernum, "This ship cannot be set for this.\n");
			free(ship);
			return;
		}
      } else if(!strncmp(args[2], "radiative", i)) {
		if(ship->type==STYPE_MINE) {
			ship->mine.mode = 0;
			notify(Playernum, "This mine is set for radiation mode.\n");
		} else {
			notify(Playernum, "This ship cannot be set for this.\n");
			free(ship);
			return;
		}
      } else if(!strncmp(args[2], "move", i)) {
		if (ship->type==OTYPE_TERRA) {
			ship->object.number = atoi(args[3]);
			ship->object.number2 = atoi(args[4]);
			if(ship->object.number != 0)
				ship->object.number = sgn(ship->object.number);
			if(ship->object.number2 != 0)
				ship->object.number2 = sgn(ship->object.number2); 
			sprintf(buf, "Terraformer moving in direction %d,%d\n",
				ship->object.number,ship->object.number2);
			notify(Playernum, buf);
		    } else {
			notify(Playernum, "That ship is not a terraformer.\n");
			free(ship);
			return;
		}
      } else if(!strncmp(args[2], "trigger", i)) {
		    if (ship->type==STYPE_MINE) {
				ship->object.number = atoi(args[3]);
			if (ship->object.number < 0)
				ship->object.number = 0;
			sprintf(buf, "Trigger radius set to %3d\n",ship->object.number); 
			notify(Playernum, buf);
		    } else {
			notify(Playernum, "This ship cannot be assigned a trigger radius.\n");
			free(ship);
			return;
			}
      } else if(!strncmp(args[2], "transport", i)) {
 		if (ship->type==OTYPE_TRANSDEV) {
			ship->object.number = atoi(args[3]);
			if(ship->object.number < 0 || ship->object.number > n_ships)
				ship->object.number = 0;
			sprintf(buf, "Target ship is %d.\n",ship->object.number);
			notify(Playernum, buf);
		    } else {
			notify(Playernum, "This ship is not a transporter.\n");
			free(ship);
			return;
			}
      } else if(!strncmp(args[2], "aim", i)) {
		    if (can_aim(ship)) {
		      if (ship->type==OTYPE_GTELE || ship->type==OTYPE_TRACT 
				  || ship->fuel>=FUEL_MANEUVER) {
      			if (ship->type==STYPE_MIRROR && ship->is_docked) {
			    sprintf(buf, "docked; use undock or launch first.\n");
				notify(Playernum, buf);
				free(ship);
				return;
      			}
			  pl = Getplace(Playernum, args[3],1);
			  if (pl.err) {
				notify(Playernum, "Error in destination.\n");
				free(ship);
				return;
			  } else {
				ship->aimed_at.level = pl.level;
				ship->aimed_at.pnum = pl.pnum;
				ship->aimed_at.snum = pl.snum;
				ship->aimed_at.shipno = pl.shipno;
				if (ship->type!=OTYPE_TRACT && 
						ship->type!=OTYPE_GTELE)
					ship->fuel -= FUEL_MANEUVER;
				if (ship->type==OTYPE_GTELE || 
						ship->type==OTYPE_STELE)
					mk_expl_aimed_at(Playernum, ship);
		        sprintf(buf, "Aimed at %s\n", prin_aimed_at(Playernum, ship) );
			notify(Playernum, buf);
			}
		      } else {
			sprintf(buf, "Not enough maneuvering fuel (%.2f).\n",FUEL_MANEUVER);
			notify(Playernum, buf);
			free(ship);
			return;
		      }


		    } else {
			notify(Playernum, "You can't aim that kind of ship.\n");
			free(ship);
			return;
			}
     } else if(!strncmp(args[2], "intensity", i)) {
		    if (ship->type==STYPE_MIRROR) { 
			      ship->aimed_at.intensity = atoi(args[3]);
			      if (ship->aimed_at.intensity>100)
				  ship->aimed_at.intensity=100;
			      else if (ship->aimed_at.intensity<0)
				  ship->aimed_at.intensity=0;
			    sprintf(buf, "Mirror intensisty set to %3d\n",ship->aimed_at.intensity); 
				notify(Playernum, buf);
		    } else {
				notify(Playernum, "You can't do that with this kind of ship.\n");
			}
 } else if(!strncmp(args[2], "on", i)) {

     if(ship->type==OTYPE_FACTORY) {
     if(ship->on) {
	 notify(Playernum, "It's already online.\n");
	 free(ship);
	 return;
		     }
/* check to see if player has enough resources to activate the factory */
     		openpdata(&order_pdata);
     		getplanet(order_pdata,&planet, Stars[ship->deststar]->planetpos[ship->destpnum]);
		close_file(order_pdata);

	if(planet->info[Playernum-1].resource < 2*ship->build_cost) {
		sprintf(buf, "You don't have %s resources on the planet to activate this factory.\n",
				2*ship->build_cost);
		notify(Playernum, buf);
		free(ship);
		free(planet);
		return;
			} else {
		planet->info[Playernum-1].resource -= 2*ship->build_cost;

     		openpdata(&order_pdata);
		putplanet(order_pdata, planet, Stars[ship->deststar]->planetpos[ship->destpnum]);
		close_file(order_pdata);
		free(planet);
		sprintf(buf, "Factory activated at a cost of %d resources.\n",
			2*ship->build_cost);
		notify(Playernum, buf);
			}

	}     
                ship->on = 1;
		notify(Playernum, "Activated.\n");
 } else if(!strncmp(args[2], "off", i)) {

     if(ship->type==OTYPE_FACTORY && ship->on) {
	 notify(Playernum, "You can't deactivate a factory once it's online. Consider using 'scrap'.\n");
	 free(ship);
	 return;
     }
     
                ship->on = 0;
		notify(Playernum, "Deactivated.\n");
} else {
		notify(Playernum, "I don't understand what you mean.\n");
 }

	       ship->notified = 0;
    openshdata(&order_shdata);
    putship(order_shdata, ship, shipno);
    close_file(order_shdata);
 } else {
	notify(Playernum, "You don't own that ship!\n");
	}

 free(ship);
}



/* 
 * return what the ship is aimed at, if it's a mirror 
 */
char *prin_aimed_at(Playernum, ship)
int Playernum;
shiptype *ship;
{
 placetype targ;

  targ.level = ship->aimed_at.level;
  targ.snum = ship->aimed_at.snum;
  targ.pnum = ship->aimed_at.pnum;
  targ.shipno = ship->aimed_at.shipno;
  return Dispplace(Playernum, &targ);
}

char *prin_ship_dest(Playernum, ship)
int Playernum;
shiptype *ship;
{
 placetype dest;

  dest.level = ship->whatdest;
  dest.snum = ship->deststar;
  dest.pnum = ship->destpnum;
  dest.shipno = ship->destshipno;
  return Dispplace(Playernum, &dest);
}


/* 
 * mark wherever the ship is aimed at, as explored by the owning player.
 */
mk_expl_aimed_at(Playernum, s)
int Playernum;
shiptype *s;
{
double dist;
startype *str;
planettype *p;
int sdata,pdata;
float xf,yf;

 str = Stars[s->aimed_at.snum];

 if (s->is_docked && s->whatdest==LEVEL_PLAN) {
	openpdata(&pdata);
	getplanet(pdata, &p, Stars[s->storbits]->planetpos[s->pnumorbits]);
	close_file(pdata);
	xf = Stars[s->storbits]->xpos + p->xpos + s->xpos;
	yf = Stars[s->storbits]->ypos + p->ypos + s->ypos;
	free(p);
 } else {
	xf = s->xpos;
	yf = s->ypos;
 }

 switch (s->aimed_at.level) {
	case LEVEL_UNIV:
		sprintf(buf, "There is nothing out here to aim at.");
		notify(Playernum, buf);
		break;
	case LEVEL_STAR:
		sprintf(buf, "Star %s ", prin_aimed_at(Playernum, s));
		notify(Playernum, buf);
		if ((dist=sqrt(Distsq(xf, yf, str->xpos, str->ypos))) <= tele_range(s->type, s->tech) ) {
			openstardata(&sdata);
			getstar(sdata, &str, s->aimed_at.snum);
			 setbit(str->explored,Playernum);
			putstar(sdata, str, s->aimed_at.snum);
			close_file(sdata);	/* don't need to care about Stars */
			sprintf(buf, "Surveyed, distance %g.\n",dist);
			notify(Playernum, buf);
		} else {
			sprintf(buf, "Too far to see (%g, max %g).\n", 
						dist, tele_range(s->type, s->tech) );
			notify(Playernum, buf);
		}
		break;
	case LEVEL_PLAN:
		sprintf(buf, "Planet %s ", prin_aimed_at(Playernum, s));
		notify(Playernum, buf);
		openpdata(&pdata);
		getplanet(pdata, &p, str->planetpos[s->aimed_at.pnum]);
		close_file(pdata);
		if ((dist=sqrt(Distsq(xf, yf, str->xpos+p->xpos, str->ypos+p->ypos))) <= tele_range(s->type,s->tech) ) {
			setbit(str->explored,Playernum);
			p->info[Playernum-1].explored = 1;
			openpdata(&pdata);
			putplanet(pdata, p, str->planetpos[s->aimed_at.pnum]);
		close_file(pdata);
			free(p);
			sprintf(buf, "Surveyed, distance %g.\n", dist);
			notify(Playernum, buf);
		} else {
			sprintf(buf, "Too far to see (%g, max %g).\n", 
						dist, tele_range(s->type, s->tech) );
			notify(Playernum, buf);
		}
		break;
	case LEVEL_SHIP:
		sprintf(buf, "You can't see anything of use there.\n");
		notify(Playernum, buf);
		break;
 }
}

DispOrdersHeader(Playernum)
int Playernum;
{
notify(Playernum, "            name          destination     orbits     spd   options\n"); 
}

DispOrders(Playernum, sh, next, check)
int Playernum;
int sh;
int *next;
int check;
{
int order_shdata, in_list;
shiptype *ship;
char temp[128];

openshdata(&order_shdata);
 if (!getship(order_shdata,&ship, sh)) {
	sprintf(buf, "order:error in getship.\n");
	notify(Playernum, buf);
	*next = 0;
	return; 
}
close_file(order_shdata);

*next = ship->nextship;

if(ship->owner != Playernum || !ship->is_alive) { /* cant look at other ships */
	free(ship);
	return;
	}

if(check) {
	int j;
	in_list = 0;
	for(j=0; j<NUMSTYPES; j++)
		if(Order_types[j] && ship->type==j) in_list = 1;
	if(!in_list) {
		free(ship);
		return;
		}
		}

	sprintf(buf, "%4d %c %14s %15s %15s %1d ", sh, Shipltrs[ship->type], ship->name, 
		prin_ship_dest(Playernum, ship), prin_ship_orbits(ship),  ship->speed);

if(ship->hyper_drive.on) {
	sprintf(temp, "/jump %s %d", (ship->hyper_drive.ready ? "ready" : "charging"),
		ship->hyper_drive.charge);
	strcat(buf, temp);
	}
if(ship->protect.self) strcat(buf, "/retal");
if(ship->protect.planet) strcat(buf, "/defense");
if(ship->protect.on) {
		sprintf(temp, "/prot %d", ship->protect.ship);
		strcat(buf, temp);
		}
if(ship->navigate.on) {
	sprintf(temp, "/nav %d (%d)", ship->navigate.bearing, ship->navigate.turns);
	strcat(buf, temp);
	}
if(has_switch(ship)) {
	if(ship->on) strcat(buf, "/on");
	else strcat(buf, "/off");
	}
if(ship->protect.evade) strcat(buf, "/evade");
if(ship->bombard) strcat(buf, "/bomb");
if(ship->type==STYPE_MINE) {
	if(ship->mine.mode) strcat(buf, "/explode");
	else strcat(buf, "/radiate");
	}
if(ship->type==OTYPE_TERRA) {
	sprintf(temp, "/(%d, %d)", ship->object.number, ship->object.number2);
	strcat(buf, temp);
	}
if(ship->type==STYPE_MINE) {
	sprintf(temp, "/trigger %d", ship->object.number);
	strcat(buf, temp);
	}
if(ship->type==OTYPE_TRANSDEV) {
	sprintf(temp, "/target %d", ship->object.number);
	strcat(buf, temp);
	}
if(ship->type == STYPE_MIRROR) {
	sprintf(temp, "/aim %s/int %d", prin_aimed_at(Playernum, ship), ship->aimed_at.intensity);
	strcat(buf, temp);
	}

strcat(buf, "\n");
notify(Playernum, buf);
/* if hyper space is on estimate how much fuel it will cost to get to the destination */
	if(ship->hyper_drive.on) {
	double dist, fuse;

	 dist = sqrt( Distsq(ship->xpos, ship->ypos, Stars[ship->deststar]->xpos, 
				Stars[ship->deststar]->ypos));
	 fuse = HYPER_DRIVE_FUEL_USE * ship->mass 
			* (dist/HYPER_DIST_FACTOR) * (dist/HYPER_DIST_FACTOR);
			sprintf(buf, "	*** jump will cost %.1ff ***\n", fuse);
			notify(Playernum, buf);
	if(ship->max_fuel < fuse)
			notify(Playernum, "Your ship cannot carry enough fuel to do this jump.\n");
		}

free(ship);
}


