/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * scrap.c -- turn a ship to junk
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <signal.h>

int scrap_shdata, scrap_pdata,scrap_sectdata, scrap_racedata;

scrap(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
planettype *planet;
sectortype *sect;
shiptype *s,*s2;
int i,mask,shipno,scrapval=0,destval=0,crewval=0;
float fuelval=0.0;

scrap_shdata = scrap_pdata = NEUTRAL_FD;

 	sscanf(args[1] + (*args[1]=='#'),"%d", &shipno);

 openshdata(&scrap_shdata);
 if (!getship(scrap_shdata,&s,shipno)) {
     close_file(scrap_shdata);
	return;
 }
close_file(scrap_shdata);

 if (s->owner!=Playernum || !s->is_alive) {
	DontOwnErr(Playernum,shipno);
	free(s);
	return;
 }

/* if(s->type==OTYPE_GOV) {
	sprintf(buf,"You can't scrap this kind of ship! **CHEATER!!!**\n");
		notify(Playernum, buf);
	return;
	} */

 if (s->whatorbits==LEVEL_UNIV) {
 	if (!enufAP(Playernum,Sdata.AP[Playernum-1], APcount))
		return;
 } else
 	if (!enufAP(Playernum,Stars[s->storbits]->AP[Playernum-1], APcount)) {
		return;
		}

free(Race);
openracedata(&scrap_racedata);
getrace(scrap_racedata, &Race, Playernum);
close_file(scrap_racedata);

 if (s->whatorbits==LEVEL_PLAN && s->type==OTYPE_TOXWC) {
	sprintf(buf,"WARNING: This will release %d toxin points back into the atmosphere!!\n", s->object.number);
		notify(Playernum, buf);
	}

 if ( !s->is_docked) {
	sprintf(buf,"%s #%d is not landed or docked.\nNo resources can be reclaimed.\n",Shipnames[s->type], shipno);
		notify(Playernum, buf);
 }

 if (s->whatorbits==LEVEL_PLAN) {		/* wc's release poison */
 	openpdata(&scrap_pdata);
 	getplanet(scrap_pdata, &planet, Stars[s->storbits]->planetpos[s->pnumorbits]);
	close_file(scrap_pdata);
	
        opensectdata(&scrap_sectdata);
        getsector(scrap_sectdata, &sect, planet->sectormappos
		 +((int)s->ypos*planet->Maxx+(int)s->xpos)*sizeof(sectortype));
	close_file(scrap_sectdata);
    }


 if (s->is_docked && s->whatdest==LEVEL_SHIP) {
     openshdata(&scrap_shdata);
     if (!getship(scrap_shdata, &s2, (int)s->destshipno)) {
	    close_file(scrap_shdata);
		return;
		}
	close_file(scrap_shdata);
	if ( !(s2->is_docked && s2->destshipno == shipno) ) {
		sprintf(buf,"Warning, other ship not docked..\n");
			notify(Playernum, buf);
		return;
	}
 } else
	s2 = (shiptype *)NULL;

 scrapval = Cost(s) * .50 + s->resource;

 if (s->is_docked) {

	 sprintf(buf,"%s #%d:original cost: %d\n",
		Shipnames[s->type], shipno, Cost(s));
			notify(Playernum, buf);
	 sprintf(buf,"         scrap value%s: %d rp's.\n",
		s->resource ? "(with stockpile) " : "", scrapval);
			notify(Playernum, buf);

	 if (s2!=NULL && s->resource+scrapval > Max_resource(s2) && s->type!=STYPE_SHUTTLE) {
		scrapval = Max_resource(s2) - s->resource;
		sprintf(buf,"(There is only room for %d resources.)\n",scrapval);
			notify(Playernum, buf);
	 }

	 if (s->fuel) {
	   sprintf(buf,"Fuel recovery: %.0f.\n", s->fuel);
			notify(Playernum, buf);
	   fuelval = s->fuel;
	   if (s2!=NULL && s->fuel+fuelval > Max_fuel(s2)) {
		fuelval = Max_fuel(s2) - s->fuel;
		sprintf(buf,"(There is only room for %.2f fuel.)\n",fuelval);
			notify(Playernum, buf);
	   }
	 } else
	   fuelval = 0.0;

	 if (s->destruct) {
	   sprintf(buf,"Weapons recovery: %d.\n", s->destruct);
			notify(Playernum, buf);
	   destval = s->destruct;
	   if (s2!=NULL && s->destruct+destval > Max_destruct(s2)) {
		destval = Max_destruct(s2) - s->destruct;
		sprintf(buf,"(There is only room for %d destruct.)\n",destval);
			notify(Playernum, buf);
	   }
	 } else
	   destval = 0;

	 if (s->popn) {
	   if (sect->owner>0 && sect->owner!=Playernum) {
		sprintf(buf,"You don't own this sector; no crew can be recovered.\n");
			notify(Playernum, buf);
	   } else {
	      sprintf(buf,"Population recovery: %d.\n", s->popn);
			notify(Playernum, buf);
	      crewval = s->popn;
	      if (s2!=NULL && s->popn+crewval > Max_crew(s2)) {
		crewval = Max_destruct(s) - s->popn;
		sprintf(buf,"(There is only room for %d crew.)\n",crewval);
			notify(Playernum, buf);
	      }
	   }
	 } else
	   crewval = 0;

}



 if (s->whatorbits==LEVEL_UNIV)
 	deductAPs(Playernum,APcount, 0, 1);
 else
 	deductAPs(Playernum,APcount, s->storbits, 0);

 kill_ship(s);
openshdata(&scrap_shdata);
putship(scrap_shdata, s, shipno);
close_file(scrap_shdata);
 if (s->is_docked && s->whatdest==LEVEL_SHIP) {
     fuelval = MIN(fuelval, 1.*Max_fuel(s2) - s2->fuel);
     destval = MIN(destval, Max_destruct(s2) - s2->destruct);
     scrapval = MIN(scrapval, Max_resource(s2) - s2->resource);
     crewval = MIN(crewval, Max_crew(s2) - s2->popn);
     s2->fuel += fuelval;
	s2->destruct += destval;
	s2->resource += scrapval;
	s2->popn += crewval;
	s2->mass += fuelval*MASS_FUEL + destval*MASS_DESTRUCT + scrapval*MASS_RESOURCE + crewval*Race->mass;
     s2->is_docked = 0; /* undock the surviving ship */
     s2->whatdest = LEVEL_UNIV;
     s2->destshipno = 0;
     openshdata(&scrap_shdata);
	putship(scrap_shdata, s2, s->destshipno);
	close_file(scrap_shdata);
    }



 if (s->whatorbits==LEVEL_PLAN) {

     /* distribute poison over planet even if orbiting */
   if (s->type==OTYPE_TOXWC) {
	if (planet->conditions[TOXIC] > 100 - s->object.number)
		planet->conditions[TOXIC] = 100;
	else
		planet->conditions[TOXIC] += s->object.number;

	sprintf(buf,"Planetary toxin concentration is now %d.\n", 
		planet->conditions[TOXIC]);
		notify(Playernum, buf);
   }

   if (s->is_docked && s->whatdest==LEVEL_PLAN) {

       if (sect->owner==Playernum) {
		sect->popn += s->popn;
       } else if (sect->owner == 0) {
		sect->owner = Playernum;
		sect->popn = s->popn;
		planet->info[Playernum-1].numsectsowned++;
		sprintf(buf,"Sector %.0f,%.0f Colonized.\n",s->xpos,s->ypos);
		notify(Playernum, buf);
       }
       opensectdata(&scrap_sectdata);
       putsector(scrap_sectdata, sect, planet->sectormappos
		 +((int)s->ypos*planet->Maxx+(int)s->xpos)*sizeof(sectortype));
       close_file(scrap_sectdata);

 	planet->info[Playernum-1].resource += scrapval;
 	planet->popn += crewval;
 	planet->info[Playernum-1].destruct += destval;
 	planet->info[Playernum-1].fuel += (int)fuelval;
   }
   openpdata(&scrap_pdata);
   putplanet(scrap_pdata, planet, Stars[s->storbits]->planetpos[s->pnumorbits]);
   close_file(scrap_pdata);

 }


   if (s->is_docked && s->whatdest==LEVEL_PLAN) {
	sprintf(buf,"\nScrapped.\n");
		notify(Playernum, buf);
   } else {
	sprintf(buf,"\nDestroyed.\n");
		notify(Playernum, buf);
		}

 free(s);
 if (s2!=NULL) free(s2);

}


